diff --git a/game/client/src/main/java/net/minecraft/client/gui/popup/PopupScreen.java b/game/client/src/main/java/net/minecraft/client/gui/popup/PopupScreen.java
index 37d3a95a2..c6af3e112 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/popup/PopupScreen.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/popup/PopupScreen.java
@@ -3,48 +3,47 @@ package net.minecraft.client.gui.popup;
 import it.unimi.dsi.fastutil.ints.IntIntPair;
 import net.minecraft.client.gui.Screen;
 import net.minecraft.client.render.tessellator.Tessellator;
-import net.minecraft.core.util.collection.Pair;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 import org.lwjgl.input.Keyboard;
 import org.lwjgl.opengl.GL11;
 
 import java.util.*;
 
 public final class PopupScreen
-    extends Screen
-{
+    extends Screen {
     static final int HORIZONTAL_MARGIN = 8;
     static final int VERTICAL_MARGIN = 8;
     static final int COMPONENT_GAP = 4;
 
 
-    private final Screen parent;
+    private final @Nullable Screen parent;
     private final int popupWidth;
     private final int popupHeight;
 
-    private final Integer statusCodeOnEsc;
-    private final Integer statusCodeOnEnter;
-    private final Integer statusCodeOnClickOut;
-    private final List<PopupComponent> components;
-    private final Map<PopupComponent, String> componentKeyMap;
-    private final List<PopupCloseListener> onCloseListeners;
+    private final @Nullable Integer statusCodeOnEsc;
+    private final @Nullable Integer statusCodeOnEnter;
+    private final @Nullable Integer statusCodeOnClickOut;
+    private final @NotNull List<@NotNull PopupComponent> components;
+    private final @NotNull Map<@NotNull PopupComponent, @NotNull String> componentKeyMap;
+    private final @NotNull List<@NotNull PopupCloseListener> onCloseListeners;
 
-    private final IntIntPair backgroundColor;
+    private final @Nullable IntIntPair backgroundColor;
 
     private int statusCode = -1;
 
     PopupScreen(
-            Screen parent,
-            int width,
-            int height,
-            Integer statusCodeOnEsc,
-            Integer statusCodeOnEnter,
-            Integer statusCodeOnClickOut,
-            List<PopupComponent> components,
-            Map<PopupComponent, String> componentKeyMap,
-            List<PopupCloseListener> onCloseListeners,
-            IntIntPair backgroundColor
-    )
-    {
+        final @Nullable Screen parent,
+        final int width,
+        final int height,
+        final @Nullable Integer statusCodeOnEsc,
+        final @Nullable Integer statusCodeOnEnter,
+        final @Nullable Integer statusCodeOnClickOut,
+        final @NotNull List<@NotNull PopupComponent> components,
+        final @NotNull Map<@NotNull PopupComponent, @NotNull String> componentKeyMap,
+        final @NotNull List<@NotNull PopupCloseListener> onCloseListeners,
+        final @Nullable IntIntPair backgroundColor
+    ) {
         this.parent = parent;
         this.popupWidth = width;
         this.popupHeight = height;
@@ -57,124 +56,104 @@ public final class PopupScreen
         this.backgroundColor = backgroundColor;
     }
 
-    void close(int statusCode)
-    {
+    void close(final int statusCode) {
         this.statusCode = statusCode;
         this.removed();
-        mc.currentScreen = parent;
+        this.mc.currentScreen = this.parent;
     }
 
     @Override
-    public void tick()
-    {
+    public void tick() {
         super.tick();
 
-        for (PopupComponent component : components)
-        {
+        for (final @NotNull PopupComponent component : this.components) {
             component.tick();
         }
     }
 
     @Override
-    public void removed()
-    {
+    public void removed() {
         super.removed();
 
-        Map<String, Object> results = new HashMap<>();
-        for (Map.Entry<PopupComponent, String> entry : componentKeyMap.entrySet())
-        {
-            if (entry.getKey() instanceof InteractivePopupComponent<?>)
-            {
-                Object value = ((InteractivePopupComponent<?>) entry.getKey()).getOutput();
+        final @NotNull Map<@NotNull String, @NotNull Object> results = new HashMap<>();
+        for (final @NotNull Map.Entry<@NotNull PopupComponent, @NotNull String> entry : this.componentKeyMap.entrySet()) {
+            if (entry.getKey() instanceof InteractivePopupComponent<?>) {
+                final @NotNull Object value = ((InteractivePopupComponent<?>) entry.getKey()).getOutput();
                 results.put(entry.getValue(), value);
             }
         }
 
-        for (PopupCloseListener listener : onCloseListeners)
-        {
-            listener.onClosed(statusCode, results);
+        for (final @NotNull PopupCloseListener listener : this.onCloseListeners) {
+            listener.onClosed(this.statusCode, results);
         }
     }
 
     @Override
-    public void init()
-    {
-        if (parent.width != width || parent.height != height)
-        {
-            parent.width = width;
-            parent.height = height;
-            parent.buttons.clear();
-            parent.init();
+    public void init() {
+        if (this.parent != null && (this.parent.width != this.width || this.parent.height != this.height)) {
+            this.parent.width = this.width;
+            this.parent.height = this.height;
+            this.parent.buttons.clear();
+            this.parent.init();
         }
 
         super.init();
     }
 
     @Override
-    public void keyPressed(char eventCharacter, int eventKey, int mx, int my)
-    {
-        if (eventKey == Keyboard.KEY_ESCAPE && statusCodeOnEsc != null)
-        {
-            close(statusCodeOnEsc);
+    public void keyPressed(final char eventCharacter, final int eventKey, final int mx, final int my) {
+        if (eventKey == Keyboard.KEY_ESCAPE && this.statusCodeOnEsc != null) {
+            this.close(this.statusCodeOnEsc);
         }
-        if ((eventKey == Keyboard.KEY_RETURN || eventKey == Keyboard.KEY_NUMPADENTER) && statusCodeOnEnter != null)
-        {
-            close(statusCodeOnEnter);
+        if ((eventKey == Keyboard.KEY_RETURN || eventKey == Keyboard.KEY_NUMPADENTER) && this.statusCodeOnEnter != null) {
+            this.close(this.statusCodeOnEnter);
         }
-        for (PopupComponent component : components)
-        {
+        for (final @NotNull PopupComponent component : this.components) {
             component.onKeyDown(eventKey, eventCharacter);
         }
     }
 
     @Override
-    public void mouseClicked(int mx, int my, int buttonNum)
-    {
-        if (statusCodeOnClickOut != null)
-        {
-            int popupX = width / 2 - popupWidth / 2;
-            int popupY = height / 2 - popupHeight / 2;
-
-            if (mx < popupX || mx > popupX + popupWidth || my < popupY || my > popupY + popupHeight)
-            {
-                close(statusCodeOnClickOut);
+    public void mouseClicked(final int mx, final int my, final int buttonNum) {
+        if (this.statusCodeOnClickOut != null) {
+            final int popupX = this.width / 2 - this.popupWidth / 2;
+            final int popupY = this.height / 2 - this.popupHeight / 2;
+
+            if (mx < popupX || mx > popupX + this.popupWidth || my < popupY || my > popupY + this.popupHeight) {
+                this.close(this.statusCodeOnClickOut);
             }
         }
 
         super.mouseClicked(mx, my, buttonNum);
 
-        for (PopupComponent component : components)
-        {
+        for (final @NotNull PopupComponent component : this.components) {
             component.onClick(mx, my, buttonNum);
         }
     }
-    
+
     @Override
-    public void mouseReleased(int mx, int my, int buttonNum)
-    {
-    	super.mouseReleased(mx, my, buttonNum);
-    	
-    	for(PopupComponent component : components) {
-    		component.mouseMovedOrUp(mx, my, buttonNum);
-    	}
+    public void mouseReleased(final int mx, final int my, final int buttonNum) {
+        super.mouseReleased(mx, my, buttonNum);
+
+        for (final @NotNull PopupComponent component : this.components) {
+            component.mouseMovedOrUp(mx, my, buttonNum);
+        }
     }
 
     @Override
-    public void render(int mx, int my, float partialTick)
-    {
-        int popupX = width / 2 - popupWidth / 2;
-        int popupY = height / 2 - popupHeight / 2;
+    public void render(final int mx, final int my, final float partialTick) {
+        final int popupX = this.width / 2 - this.popupWidth / 2;
+        final int popupY = this.height / 2 - this.popupHeight / 2;
 
         if (this.parent != null) {
-            parent.render(-1, -1, partialTick);
+            this.parent.render(-1, -1, partialTick);
         }
 
-        drawPopupBackground();
+        this.drawPopupBackground();
 
         int accY = popupY + VERTICAL_MARGIN;
 
-        for (PopupComponent component : components)
-        {
+        for (final @NotNull PopupComponent component : this.components) {
             component.render(popupX + HORIZONTAL_MARGIN, accY, mx, my);
             accY += component.getHeight() + COMPONENT_GAP;
         }
@@ -182,34 +161,32 @@ public final class PopupScreen
         super.render(mx, my, partialTick);
     }
 
-    private void drawPopupBackground()
-    {
-        int popupX = width / 2 - popupWidth / 2;
-        int popupY = height / 2 - popupHeight / 2;
+    private void drawPopupBackground() {
+        final int popupX = this.width / 2 - this.popupWidth / 2;
+        final int popupY = this.height / 2 - this.popupHeight / 2;
 
         GL11.glDisable(GL11.GL_LIGHTING);
         GL11.glDisable(GL11.GL_FOG);
-        Tessellator tessellator = Tessellator.instance;
+        final @NotNull Tessellator tessellator = Tessellator.instance;
         GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
 
-        if(backgroundColor == null){
-            int color = mc.gameSettings.guiBackgroundColor.value.getARGB();
-            drawGradientRect(0, 0, width, height, color, color);
+        if (this.backgroundColor == null) {
+            final int color = this.mc.gameSettings.guiBackgroundColor.value.getARGB();
+            this.drawGradientRect(0, 0, this.width, this.height, color, color);
         } else {
-            drawGradientRect(0, 0, width, height, backgroundColor.leftInt(), backgroundColor.rightInt());
+            this.drawGradientRect(0, 0, this.width, this.height, this.backgroundColor.leftInt(), this.backgroundColor.rightInt());
         }
 
-
-        drawRectWidthHeight(popupX - 1, popupY - 1, popupWidth + 2, popupHeight + 2, 0xFFA0A0A0);
+        this.drawRectWidthHeight(popupX - 1, popupY - 1, this.popupWidth + 2, this.popupHeight + 2, 0xFFA0A0A0);
 
         GL11.glEnable(GL11.GL_TEXTURE_2D);
-        float f = 32F;
+        final float f = 32F;
         tessellator.startDrawingQuads();
-        mc.textureManager.loadTexture("/assets/minecraft/textures/gui/background.png").bind();
+        this.mc.textureManager.loadTexture("/assets/minecraft/textures/gui/background.png").bind();
         tessellator.setColorOpaque_I(0x404040);
-        tessellator.addVertexWithUV(popupX, popupY + popupHeight, 0.0D, 0.0D, (float)popupHeight / f);
-        tessellator.addVertexWithUV(popupX + popupWidth, popupY + popupHeight, 0.0D, (float)popupWidth / f, (float)popupHeight / f);
-        tessellator.addVertexWithUV(popupX + popupWidth, popupY, 0.0D, (float)popupWidth / f, 0);
+        tessellator.addVertexWithUV(popupX, popupY + this.popupHeight, 0.0D, 0.0D, (float) this.popupHeight / f);
+        tessellator.addVertexWithUV(popupX + this.popupWidth, popupY + this.popupHeight, 0.0D, (float) this.popupWidth / f, (float) this.popupHeight / f);
+        tessellator.addVertexWithUV(popupX + this.popupWidth, popupY, 0.0D, (float) this.popupWidth / f, 0);
         tessellator.addVertexWithUV(popupX, popupY, 0.0D, 0.0D, 0);
         tessellator.draw();
     }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/popup/TextInputComponent.java b/game/client/src/main/java/net/minecraft/client/gui/popup/TextInputComponent.java
index 60a0a693c..c77703f99 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/popup/TextInputComponent.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/popup/TextInputComponent.java
@@ -2,6 +2,7 @@ package net.minecraft.client.gui.popup;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.TextFieldElement;
+import org.jetbrains.annotations.NotNull;
 
 public class TextInputComponent
     extends InteractivePopupComponent<String>
@@ -22,7 +23,7 @@ public class TextInputComponent
     }
 
     @Override
-    public String getOutput()
+    public @NotNull String getOutput()
     {
         return textField.getText();
     }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/worldsettings/BooleanGameRuleComponent.java b/game/client/src/main/java/net/minecraft/client/gui/worldsettings/BooleanGameRuleComponent.java
index 1fb8f6580..fcb5c878b 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/worldsettings/BooleanGameRuleComponent.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/worldsettings/BooleanGameRuleComponent.java
@@ -13,11 +13,10 @@ public class BooleanGameRuleComponent
     extends ButtonComponent
 {
     private @Nullable GameRuleCollection gameRuleCollection = null;
-    private final GameRuleBoolean gameRule;
-    private final SwitchElement button;
+    private final @NotNull GameRuleBoolean gameRule;
+    private final @NotNull SwitchElement button;
 
-    public BooleanGameRuleComponent(GameRuleBoolean gameRule)
-    {
+    public BooleanGameRuleComponent(final @NotNull GameRuleBoolean gameRule) {
         super(gameRule.getTranslationKey() + ".name", gameRule.getTranslationKey() + ".desc");
 
         this.gameRule = gameRule;
@@ -31,34 +30,36 @@ public class BooleanGameRuleComponent
 
     @Override
     public void resetValue() {
-        gameRuleCollection.setValue(this.gameRule, this.gameRule.getDefaultValue());
-        onChange();
+        assert this.gameRuleCollection != null;
+        this.gameRuleCollection.setValue(this.gameRule, this.gameRule.getDefaultValue());
+        this.onChange();
     }
 
     @Override
-    public void init(Minecraft mc){
-        onChange();
+    public void init(final @NotNull Minecraft mc){
+        this.onChange();
     }
 
     @Override
     public boolean isDefault() {
-        return gameRuleCollection.getValue(this.gameRule).equals(gameRule.getDefaultValue());
+        assert this.gameRuleCollection != null;
+        return this.gameRuleCollection.getValue(this.gameRule).equals(this.gameRule.getDefaultValue());
     }
 
     @Override
-    protected void buttonClicked(int mouseButton, int x, int y, int width, int height, int relativeMouseX, int relativeMouseY)
-    {
-        gameRuleCollection.setValue(this.gameRule, !this.gameRuleCollection.getValue(this.gameRule));
-        onChange();
+    protected void buttonClicked(final int mouseButton, final int x, final int y, final int width, final int height, final int relativeMouseX, final int relativeMouseY) {
+        assert this.gameRuleCollection != null;
+        this.gameRuleCollection.setValue(this.gameRule, !this.gameRuleCollection.getValue(this.gameRule));
+        this.onChange();
     }
 
     protected void onChange() {
+        assert this.gameRuleCollection != null;
         this.button.setOn(this.gameRuleCollection.getValue(this.gameRule));
     }
 
     @Override
-    protected void renderButton(int x, int y, int relativeButtonX, int relativeButtonY, int buttonWidth, int buttonHeight, int relativeMouseX, int relativeMouseY)
-    {
+    protected void renderButton(final int x, final int y, final int relativeButtonX, final int relativeButtonY, final int buttonWidth, final int buttonHeight, final int relativeMouseX, final int relativeMouseY) {
         super.renderButton(x, y, relativeButtonX, relativeButtonY, buttonWidth, buttonHeight, relativeMouseX, relativeMouseY);
 
         this.button.xPosition = x + relativeButtonX;
@@ -68,7 +69,7 @@ public class BooleanGameRuleComponent
 
         this.button.drawButton(mc, x + relativeMouseX, y + relativeMouseY);
 
-        if (relativeMouseX >= relativeButtonX && relativeMouseX < relativeButtonX + buttonWidth && relativeMouseY >= relativeButtonY && relativeButtonY < relativeButtonY + buttonHeight) {
+        if (mc.currentScreen != null && relativeMouseX >= relativeButtonX && relativeMouseX < relativeButtonX + buttonWidth && relativeMouseY >= relativeButtonY && relativeButtonY < relativeButtonY + buttonHeight) {
             mc.currentScreen.setDesiredCursor(CursorShape.HAND);
         }
     }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/worldsettings/ButtonComponent.java b/game/client/src/main/java/net/minecraft/client/gui/worldsettings/ButtonComponent.java
index 654639ba5..daf0493d4 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/worldsettings/ButtonComponent.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/worldsettings/ButtonComponent.java
@@ -15,25 +15,21 @@ import static org.lwjgl.opengl.GL11.*;
 import static org.lwjgl.opengl.GL11.GL_BLEND;
 
 public abstract class ButtonComponent
-    implements PageComponent
-{
-    protected static final Minecraft mc = Minecraft.getMinecraft();
+    implements PageComponent {
+    protected static final @NotNull Minecraft mc = Minecraft.getMinecraft();
     protected static final int COMPONENT_SPACING = 2;
     private static final int BUTTON_WIDTH = 100;
 
     private final @NotNull String translationKey;
     private final @Nullable String tooltipTranslationKey;
 
-    protected final ButtonElement resetButton;
+    protected final @NotNull ButtonElement resetButton;
 
-    private boolean hovered = false;
-
-    public ButtonComponent(@NotNull String translationKey, @Nullable String tooltipTranslationKey)
-    {
+    public ButtonComponent(final @NotNull String translationKey, final @Nullable String tooltipTranslationKey) {
         this.translationKey = translationKey;
         this.tooltipTranslationKey = tooltipTranslationKey;
         this.resetButton = new ButtonElement(0, 0, 0, 20, 20, "")
-                .setTextures("minecraft:gui/misc/icon_reset", "minecraft:gui/misc/icon_reset_highlighted", "minecraft:gui/misc/icon_reset");
+            .setTextures("minecraft:gui/misc/icon_reset", "minecraft:gui/misc/icon_reset_highlighted", "minecraft:gui/misc/icon_reset");
     }
 
     public abstract void resetValue();
@@ -41,78 +37,71 @@ public abstract class ButtonComponent
     public abstract boolean isDefault();
 
     @Override
-    public int getHeight()
-    {
+    public int getHeight() {
         return COMPONENT_SPACING + 20 + COMPONENT_SPACING;
     }
 
     @Override
-    public void render(int x, int y, int width, int relativeMouseX, int relativeMouseY)
-    {
-        String translated = I18n.getInstance().translateKey(translationKey);
+    public void render(final int x, final int y, final int width, final int relativeMouseX, final int relativeMouseY) {
+        final @NotNull String translated = I18n.getInstance().translateKey(this.translationKey);
         int textColor = 0xFFFFFFFF;
-        if (relativeMouseX >= 0 && relativeMouseX <= width && relativeMouseY >= COMPONENT_SPACING && relativeMouseY <= getHeight() - COMPONENT_SPACING) {
+        if (relativeMouseX >= 0 && relativeMouseX <= width && relativeMouseY >= COMPONENT_SPACING && relativeMouseY <= this.getHeight() - COMPONENT_SPACING) {
             textColor = 0xFFFFFFA0;
         }
 
-        if (relativeMouseX >= 0 && relativeMouseX <= width - BUTTON_WIDTH && relativeMouseY >= COMPONENT_SPACING && relativeMouseY <= getHeight() - COMPONENT_SPACING) {
-            this.hovered = true;
-        } else {
-            this.hovered = false;
-        }
-
-        mc.font.render(Tessellator.instance, translated, x, y + (getHeight() / 2) - 4).setShadow().setColor(textColor).call();
-        resetButton.enabled = !isDefault();
-        renderButton(x, y, width - BUTTON_WIDTH, COMPONENT_SPACING, BUTTON_WIDTH, 20, relativeMouseX, relativeMouseY);
-        int stringWidth = mc.font.stringWidth(translated);
+        mc.font.render(Tessellator.instance, translated, x, y + (this.getHeight() / 2) - 4).setShadow().setColor(textColor).call();
+        this.resetButton.enabled = !this.isDefault();
+        this.renderButton(x, y, width - BUTTON_WIDTH, COMPONENT_SPACING, BUTTON_WIDTH, 20, relativeMouseX, relativeMouseY);
+        final int stringWidth = mc.font.stringWidth(translated);
         int lineMaxX = x + width - BUTTON_WIDTH - 8;
-        if (resetButton.enabled) lineMaxX -= 20;
-        drawRect(x + stringWidth + 8, y + getHeight() / 2, lineMaxX, y + getHeight() / 2 + 1, 0x5F7F7F7F);
+        if (this.resetButton.enabled) lineMaxX -= 20;
+        this.drawRect(x + stringWidth + 8, y + this.getHeight() / 2, lineMaxX, y + this.getHeight() / 2 + 1, 0x5F7F7F7F);
     }
 
     @Override
-    public void onMouseClick(int mouseButton, int x, int y, int width, int relativeMouseX, int relativeMouseY)
-    {
+    public void onMouseClick(final int mouseButton, final int x, final int y, final int width, final int relativeMouseX, final int relativeMouseY) {
         if (relativeMouseX >= width - BUTTON_WIDTH && relativeMouseX <= width && relativeMouseY >= COMPONENT_SPACING && relativeMouseY <= COMPONENT_SPACING + 20) {
             mc.sndManager.playSound("random.click", SoundCategory.GUI_SOUNDS, 1.0F, 1.0F);
-            buttonClicked(mouseButton, x, y, width, getHeight(), relativeMouseX - (width - BUTTON_WIDTH), relativeMouseY - COMPONENT_SPACING);
-        } else if (resetButton.enabled && relativeMouseX >= width - BUTTON_WIDTH - 20 && relativeMouseX <= width - BUTTON_WIDTH && relativeMouseY >= COMPONENT_SPACING && relativeMouseY <= COMPONENT_SPACING + 20) {
+            this.buttonClicked(mouseButton, x, y, width, this.getHeight(), relativeMouseX - (width - BUTTON_WIDTH), relativeMouseY - COMPONENT_SPACING);
+        } else if (this.resetButton.enabled && relativeMouseX >= width - BUTTON_WIDTH - 20 && relativeMouseX <= width - BUTTON_WIDTH && relativeMouseY >= COMPONENT_SPACING && relativeMouseY <= COMPONENT_SPACING + 20) {
             mc.sndManager.playSound("random.click", SoundCategory.GUI_SOUNDS, 1.0F, 1.0F);
-            resetValue();
+            this.resetValue();
         }
     }
 
     @Override
-    public void onMouseMove(int x, int y, int width, int relativeMouseX, int relativeMouseY) {
-        buttonDragged(x, y, width, getHeight(), relativeMouseX - (width - BUTTON_WIDTH), relativeMouseY - COMPONENT_SPACING);
+    public void onMouseMove(final int x, final int y, final int width, final int relativeMouseX, final int relativeMouseY) {
+        this.buttonDragged(x, y, width, this.getHeight(), relativeMouseX - (width - BUTTON_WIDTH), relativeMouseY - COMPONENT_SPACING);
     }
 
     @Override
-    public void onMouseRelease(int mouseButton, int x, int y, int width, int relativeMouseX, int relativeMouseY) {
-        buttonReleased(mouseButton, x, y, width, getHeight(), relativeMouseX - (width - BUTTON_WIDTH), relativeMouseY - COMPONENT_SPACING);
+    public void onMouseRelease(final int mouseButton, final int x, final int y, final int width, final int relativeMouseX, final int relativeMouseY) {
+        this.buttonReleased(mouseButton, x, y, width, this.getHeight(), relativeMouseX - (width - BUTTON_WIDTH), relativeMouseY - COMPONENT_SPACING);
     }
 
     protected abstract void buttonClicked(int mouseButton, int x, int y, int width, int height, int relativeMouseX, int relativeMouseY);
 
-    protected void buttonDragged(int x, int y, int width, int height, int relativeMouseX, int relativeMouseY) { }
+    protected void buttonDragged(final int x, final int y, final int width, final int height, final int relativeMouseX, final int relativeMouseY) {
+    }
 
-    protected void buttonReleased(int mouseButton, int x, int y, int width, int height, int relativeMouseX, int relativeMouseY) { }
+    protected void buttonReleased(final int mouseButton, final int x, final int y, final int width, final int height, final int relativeMouseX, final int relativeMouseY) {
+    }
 
     @Override
-    public void onKeyPress(int keyCode, char character) { }
+    public void onKeyPress(final int keyCode, final char character) {
+    }
 
     @Override
-    public boolean matchesSearchTerm(String term)
-    {
-        return I18n.getInstance().translateKey(translationKey).toLowerCase().contains(term.toLowerCase());
+    public boolean matchesSearchTerm(final @NotNull String term) {
+        return I18n.getInstance().translateKey(this.translationKey).toLowerCase().contains(term.toLowerCase());
     }
 
-    protected void renderButton(int x, int y, int relativeButtonX, int relativeButtonY, int buttonWidth, int buttonHeight, int relativeMouseX, int relativeMouseY) {
-        if (resetButton.enabled) {
-            resetButton.xPosition = x + relativeButtonX - 20;
-            resetButton.yPosition = y + relativeButtonY;
+    protected void renderButton(final int x, final int y, final int relativeButtonX, final int relativeButtonY, final int buttonWidth, final int buttonHeight, final int relativeMouseX, final int relativeMouseY) {
+        if (this.resetButton.enabled) {
+            this.resetButton.xPosition = x + relativeButtonX - 20;
+            this.resetButton.yPosition = y + relativeButtonY;
 
-            resetButton.drawButton(mc, x + relativeMouseX, y + relativeMouseY);
+            this.resetButton.drawButton(mc, x + relativeMouseX, y + relativeMouseY);
 
             if (relativeMouseX >= relativeButtonX && relativeMouseX < relativeButtonX + buttonWidth && relativeMouseY >= relativeButtonY && relativeButtonY < relativeButtonY + buttonHeight) {
                 mc.currentScreen.setDesiredCursor(CursorShape.HAND);
@@ -120,9 +109,8 @@ public abstract class ButtonComponent
         }
     }
 
-    protected void drawRect(int minX, int minY, int maxX, int maxY, int argb)
-    {
-        Tessellator tessellator = Tessellator.instance;
+    protected void drawRect(final int minX, final int minY, final int maxX, final int maxY, final int argb) {
+        final Tessellator tessellator = Tessellator.instance;
         GL11.glEnable(GL_BLEND);
         GL11.glDisable(GL_TEXTURE_2D);
         GL11.glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
diff --git a/game/client/src/main/java/net/minecraft/client/gui/worldsettings/IntegerGameRuleComponent.java b/game/client/src/main/java/net/minecraft/client/gui/worldsettings/IntegerGameRuleComponent.java
new file mode 100644
index 000000000..153aae41b
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/gui/worldsettings/IntegerGameRuleComponent.java
@@ -0,0 +1,50 @@
+package net.minecraft.client.gui.worldsettings;
+
+import net.minecraft.client.gui.SwitchElement;
+import net.minecraft.client.gui.TextFieldElement;
+import net.minecraft.core.data.gamerule.GameRuleBoolean;
+import net.minecraft.core.data.gamerule.GameRuleCollection;
+import net.minecraft.core.data.gamerule.GameRuleInteger;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+
+public class IntegerGameRuleComponent
+    extends ButtonComponent {
+    private @Nullable GameRuleCollection gameRuleCollection = null;
+    private final @NotNull GameRuleInteger gameRule;
+    private final @NotNull TextFieldElement textField;
+
+    public IntegerGameRuleComponent(final @NotNull GameRuleInteger gameRule) {
+        super(gameRule.getTranslationKey() + ".name", gameRule.getTranslationKey() + ".desc");
+
+        this.gameRule = gameRule;
+        this.textField = new TextFieldElement(mc.currentScreen, mc.font, 0, 0, 150, 20, this.gameRule.getDefaultValue().toString(), null);
+    }
+
+    public void setGameRuleCollection(final @NotNull GameRuleCollection collection) {
+        this.gameRuleCollection = collection;
+    }
+
+    @Override
+    public void resetValue() {
+        assert this.gameRuleCollection != null;
+        this.gameRuleCollection.setValue(this.gameRule, this.gameRule.getDefaultValue());
+        this.onChange();
+    }
+
+    @Override
+    public boolean isDefault() {
+        assert this.gameRuleCollection != null;
+        return this.gameRuleCollection.getValue(this.gameRule).equals(this.gameRule.getDefaultValue());
+    }
+
+    @Override
+    protected void buttonClicked(final int mouseButton, final int x, final int y, final int width, final int height, final int relativeMouseX, final int relativeMouseY) {
+
+    }
+
+    protected void onChange() {
+        assert this.gameRuleCollection != null;
+        this.textField.setText(this.gameRuleCollection.getValue(this.gameRule).toString());
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/gui/worldsettings/ScreenWorldSettings.java b/game/client/src/main/java/net/minecraft/client/gui/worldsettings/ScreenWorldSettings.java
index 751a62ca9..87c7514f6 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/worldsettings/ScreenWorldSettings.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/worldsettings/ScreenWorldSettings.java
@@ -11,6 +11,7 @@ import net.minecraft.core.data.registry.Registries;
 import net.minecraft.core.item.Items;
 import net.minecraft.core.world.settings.WorldConfiguration;
 import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 
 import java.util.List;
 
@@ -33,20 +34,20 @@ public class ScreenWorldSettings
 
     private final @NotNull WorldConfiguration worldConfiguration;
 
-    public ScreenWorldSettings(Screen parent, final @NotNull WorldConfiguration worldConfiguration) {
+    public ScreenWorldSettings(final @Nullable Screen parent, final @NotNull WorldConfiguration worldConfiguration) {
         super(parent, CREATE_WORLD_PAGES, PAGE_GAME_RULES, "gui.world_settings.label.title", new String[] { "gui.world_settings.button.done" });
 
         this.worldConfiguration = worldConfiguration;
 
         final List<PageComponent> gameRulesPageComponents = PAGE_GAME_RULES.getComponents();
-        for (PageComponent component : gameRulesPageComponents) {
+        for (final @NotNull  PageComponent component : gameRulesPageComponents) {
             if (component instanceof BooleanGameRuleComponent) {
                 ((BooleanGameRuleComponent) component).setGameRuleCollection(worldConfiguration.getGameRuleCollection());
             }
         }
 
         final List<PageComponent> worldSettingsPageComponents = PAGE_WORLD_SETTINGS.getComponents();
-        for (PageComponent component : worldSettingsPageComponents) {
+        for (final @NotNull PageComponent component : worldSettingsPageComponents) {
             if (component instanceof WorldTypeButtonComponent) {
                 ((WorldTypeButtonComponent) component).setWorldConfiguration(worldConfiguration);
             }
